/*
 *  GOL - Game of life simulation software
 *  Copyright (C) 1996 Michael Raymond Brown
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Author: Michael Raymond Brown
 *  EMail:  michael@arrakeen.demon.co.uk
 *  WWW:    http://www.arrakeen.demon.co.uk/
 *  Address:  Michael Brown
 *            Kia Ora
 *            Brook Street
 *            Great Bromley
 *            Nr Colchester
 *            Essex
 *            CO7 7HX
 *            England
 */


#ifdef __GNUC__
#pragma implementation
#endif

#include "Idle.h"


xwIdle::xwIdle(xwWidget* p, xwApp* app)
   {parent=p;
    delay=-1;
    context=app->getApp();

    default_callbacks(0, meth_Close);
    linkParent(p);
   }
xwIdle::xwIdle(xwWidget* p, xwApp* app, int ms)
   {parent=p;
    context=app->getApp();
    delay=ms;
    add_cb();

    default_callbacks(0, meth_Close);
    linkParent(p);
   }
xwIdle::~xwIdle()
   {remove_cb();
   }

void xwIdle::setDelay(int ms)
   {remove_cb();
    delay=ms;
    add_cb();
   }

void xwIdle::add_cb()
   {
    if (delay==-1){
	int_id=0;
    }else{
	int_id=XtAppAddTimeOut(context, delay, int_proc, (XtPointer)this);
   }}
void xwIdle::remove_cb()
   {
    if (delay!=-1){
	if (int_id) XtRemoveTimeOut(int_id);
    }
    delay=-1;
   }


void xwIdle::int_proc(XtPointer client, XtIntervalId* id)
   {xwIdle* me = (xwIdle*)client;
    me->add_cb();
    if (me->handler) me->handler->onIdle(me, me->handler_arg);
   }

